//********************************************************************************************
// RC Model Servo
// Original code By EAOROBBIE (Robert Lindsay)
// Completely mangled by aarondc
// For free use for Sim Tool Motion Software
//********************************************************************************************
#include <Servo.h>
//#define DEBUG 1                                    // comment out this line to remove debuggin Serial.print lines
const int kActuatorCount = 4;                       // how many Actuators we are handling

// the letters ("names") sent from Sim Tools to identify each actuator
// NB: the order of the letters here determines the order of the remaining constants kPins and kActuatorScale
const char kActuatorName[kActuatorCount] = { 'R', 'L' };
const int kPins[kActuatorCount] = {4,5,6,7};                       // pins to which the Actuators are attached
const int kActuatorScale[kActuatorCount][2] = { { 0, 179 } ,    // Right Actuator scaling
                                                { 179, 0 }      // Left side Actuator scaling
                                               };      
const char kEOL = '~';                              // End of Line - the delimiter for our acutator values 
const int kMaxCharCount = 3;                        // some insurance...
Servo actuatorSet[kActuatorCount];                  // our array of Actuators
int actuatorPosition[kActuatorCount] = {90, 90};    // current Actuator positions, initialised to 90
int currentActuator;                                // keep track of the current Actuator being read in from serial port
int valueCharCount = 0;                             // how many value characters have we read (must be less than kMaxCharCount!!


void setup()
{ 
    // attach the Actuators to the pins
    for (int i = 0; i < kActuatorCount; i++) 
        actuatorSet[i].attach(kPins[i]);
    

    
} 
 
void loop()
{ 

//Surge
//This is with zero point starting further forward by 30
//const int kActuatorScale[kActuatorCount][2] = { { 115, 70 } ,    // Right Actuator scaling
//                                                { 65, 110 }      // Left side Actuator scaling


  
int deg=45;
int dely=30;

int S0=140;   //0 is SERVO 1    140 to 090 RIGHT HEAVE
int S1=76;    // 76 to 126      076 to 126 LEFT HEAVE
int S2=115;   //  115 to 070 RIGHT SURGE
int S3=65;    //  065 to 110 LEFT SURGE


  for (int x=0;x<deg;x++) {
    actuatorSet[0].write(S0-x);       //0 is SERVO #1
    actuatorSet[1].write(x+S1);
    actuatorSet[2].write(S2-x);       
    actuatorSet[3].write(x+S3);
        delay(dely);        // pauses for 1000 microseconds     
  }

   delay(2000);        // pauses for 1000 microseconds     

  for (int x=deg;x>0;x--) {
    actuatorSet[0].write(S0-x);
    actuatorSet[1].write(x+S1);
    actuatorSet[2].write(S2-x);       
    actuatorSet[3].write(x+S3);
        delay(dely);        // pauses for 1000 microseconds     
  }

   delay(5000);        // pauses for 1000 microseconds 
    
//max
  //                actuatorSet[0].write(53); //Right
 //   actuatorSet[1].write(200);//Left
   // digitalWrite(13,HIGH);
 //   delay(1000);        // pauses for 1000 microseconds     

//close
    //             actuatorSet[0].write(108);//Right
 //   actuatorSet[1].write(270);//Left
  //  digitalWrite(13,LOW);
  //  delay(2000);        // pauses for 1000 microseconds     


}


